package sun.net.smtp;

import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.io.OutputStream;
import java.io.PrintStream;

class SmtpPrintStream extends PrintStream
{
    private SmtpClient target;
    private int lastc;
    
    SmtpPrintStream(OutputStream out, SmtpClient target) throws UnsupportedEncodingException {
        super(out, false, target.getEncoding());
        this.lastc = 10;
        this.target = target;
    }
    
    @Override
    public void close() {
        if (this.target == null) {
            return;
        }
        if (this.lastc != 10) {
            this.write(10);
        }
        try {
            this.target.issueCommand(".\r\n", 250);
            this.target.message = null;
            this.out = null;
            this.target = null;
        }
        catch (IOException ex) {}
        return;
    }
    
    @Override
    public void write(int lastc) {
        try {
            if (this.lastc == 10 && lastc == 46) {
                this.out.write(46);
            }
            if (lastc == 10 && this.lastc != 13) {
                this.out.write(13);
            }
            this.out.write(lastc);
            this.lastc = lastc;
        }
        catch (IOException ex) {}
    }
    
    @Override
    public void write(byte[] array, int n, int n2) {
        try {
            int lastc = this.lastc;
            while (--n2 >= 0) {
                int n3 = array[n++];
                if (lastc == 10 && n3 == 46) {
                    this.out.write(46);
                }
                if (n3 == 10 && lastc != 13) {
                    this.out.write(13);
                }
                this.out.write(n3);
                lastc = n3;
            }
            this.lastc = lastc;
        }
        catch (IOException ex) {}
    }
    
    @Override
    public void print(String s) {
        for (int length = s.length(), i = 0; i < length; ++i) {
            this.write((int)s.charAt(i));
        }
    }
}
